ON_ClassArray< T > Class Template Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_array.h>`

Inheritance diagram for ON_ClassArray< T >:

## Public Member Functions

| ON_ClassArray ()
| ON_ClassArray (int)
| ON_ClassArray (const ON_ClassArray< T > &)
virtual | ~ON_ClassArray ()
ON_ClassArray< T > & | operator= (const ON_ClassArray< T > &)
void | EmergencyDestroy (void)
int | Count () const
unsigned int | UnsignedCount () const
int | Capacity () const
unsigned int | SizeOfArray () const
unsigned int | SizeOfElement () const
T & | operator[] (int)
T & | operator[] (unsigned int)
T & | operator[] (ON__INT64)
T & | operator[] (ON__UINT64)
const T & | operator[] (int) const
const T & | operator[] (unsigned int) const
const T & | operator[] (ON__INT64) const
const T & | operator[] (ON__UINT64) const
| operator T* ()
| operator const T * () const
T * | First ()
const T * | First () const
T * | At (int)
T * | At (unsigned int)
T * | At (ON__INT64)
T * | At (ON__UINT64)
const T * | At (int) const
const T * | At (unsigned int) const
const T * | At (ON__INT64) const
const T * | At (ON__UINT64) const
T * | Last ()
const T * | Last () const
T & | AppendNew ()
void | Append (const T &)
void | Append (int, const T *)
void | Insert (int, const T &)
void | Remove ()
void | Remove (int)
void | Empty ()
void | Reverse ()
void | Swap (int, int)
int | Search (const T *, int(*)(const T *, const T *)) const
int | BinarySearch (const T *, int(*)(const T *, const T *)) const
int | BinarySearch (const T *, int(*)(const T *, const T *), int) const
virtual bool | HeapSort (int(*)(const T *, const T *))
virtual bool | QuickSort (int(*)(const T *, const T *))
bool | Sort (ON::sort_algorithm sort_algorithm, int *, int(*)(const T *, const T *)) const
bool | Sort (ON::sort_algorithm sort_algorithm, int *, int(*)(const T *, const T *, void *), void *) const
bool | Permute (const int *)
void | Zero ()
void | Reserve (int)
void | Shrink ()
void | Destroy ()
virtual T * | Realloc (T *, int)
T * | Array ()
const T * | Array () const
void | SetCount (int)
void | SetCapacity (int)
int | NewCapacity () const
T * | KeepArray ()
void | SetArray (T *)
void | SetArray (T *, int, int)

## Protected Member Functions

void | Move (int, int, int)
void | ConstructDefaultElement (T *)
void | DestroyElement (T &)

## Protected Attributes

T * | m_a
int | m_count
int | m_capacity

## Detailed Description

### template<class T>
class ON_ClassArray< T >

Definition at line 821 of file opennurbs_array.h.

## Constructor & Destructor Documentation

## ON_ClassArray() [1/3]

template<class T >

ON_ClassArray< T >::ON_ClassArray

Definition at line 937 of file opennurbs_array_defs.h.

## ON_ClassArray() [2/3]

template<class T >

ON_ClassArray< T >::ON_ClassArray | ( | int | c | ) |

Definition at line 944 of file opennurbs_array_defs.h.

## ON_ClassArray() [3/3]

template<class T >

ON_ClassArray< T >::ON_ClassArray | ( | const ON_ClassArray< T > & | src | ) |

Definition at line 955 of file opennurbs_array_defs.h.

## ~ON_ClassArray()

template<class T >

ON_ClassArray< T >::~ON_ClassArray

virtual

Definition at line 964 of file opennurbs_array_defs.h.

## Member Function Documentation

## Append() [1/2]

template<class T >

void ON_ClassArray< T >::Append | ( | const T & | x | ) |

Definition at line 1316 of file opennurbs_array_defs.h.

## Append() [2/2]

template<class T >

void ON_ClassArray< T >::Append | ( | int | count,
|  | const T * | p
| ) |  |

Definition at line 1343 of file opennurbs_array_defs.h.

## AppendNew()

template<class T >

T & ON_ClassArray< T >::AppendNew

Definition at line 1298 of file opennurbs_array_defs.h.

## Array() [1/2]

template<class T >

T * ON_ClassArray< T >::Array

Definition at line 1144 of file opennurbs_array_defs.h.

## Array() [2/2]

template<class T >

const T * ON_ClassArray< T >::Array

Definition at line 1150 of file opennurbs_array_defs.h.

## At() [1/8]

template<class T >

T * ON_ClassArray< T >::At | ( | int | i | ) |

Definition at line 1196 of file opennurbs_array_defs.h.

## At() [2/8]

template<class T >

const T * ON_ClassArray< T >::At | ( | int | i | ) | const

Definition at line 1208 of file opennurbs_array_defs.h.

## At() [3/8]

template<class T >

T * ON_ClassArray< T >::At | ( | ON__INT64 | i | ) |

Definition at line 1221 of file opennurbs_array_defs.h.

## At() [4/8]

template<class T >

const T * ON_ClassArray< T >::At | ( | ON__INT64 | i | ) | const

Definition at line 1233 of file opennurbs_array_defs.h.

## At() [5/8]

template<class T >

T * ON_ClassArray< T >::At | ( | ON__UINT64 | i | ) |

Definition at line 1227 of file opennurbs_array_defs.h.

## At() [6/8]

template<class T >

const T * ON_ClassArray< T >::At | ( | ON__UINT64 | i | ) | const

Definition at line 1239 of file opennurbs_array_defs.h.

## At() [7/8]

template<class T >

T * ON_ClassArray< T >::At | ( | unsigned int | i | ) |

Definition at line 1202 of file opennurbs_array_defs.h.

## At() [8/8]

template<class T >

const T * ON_ClassArray< T >::At | ( | unsigned int | i | ) | const

Definition at line 1214 of file opennurbs_array_defs.h.

## BinarySearch() [1/2]

template<class T >

int ON_ClassArray< T >::BinarySearch | ( | const T * | key,
|  | int(*)(const T *, const T *) | compar
| ) |  | const

Definition at line 1465 of file opennurbs_array_defs.h.

## BinarySearch() [2/2]

template<class T >

int ON_ClassArray< T >::BinarySearch | ( | const T * | key,
|  | int(*)(const T *, const T *) | compar,
|  | int | count
| ) |  | const

Definition at line 1478 of file opennurbs_array_defs.h.

## Capacity()

template<class T >

int ON_ClassArray< T >::Capacity

Definition at line 1017 of file opennurbs_array_defs.h.

## ConstructDefaultElement()

template<class T >

void ON_ClassArray< T >::ConstructDefaultElement | ( | T * | p | ) |

protected

Definition at line 1284 of file opennurbs_array_defs.h.

## Count()

template<class T >

int ON_ClassArray< T >::Count

Definition at line 1005 of file opennurbs_array_defs.h.

## Destroy()

template<class T >

void ON_ClassArray< T >::Destroy

Definition at line 1651 of file opennurbs_array_defs.h.

## DestroyElement()

template<class T >

void ON_ClassArray< T >::DestroyElement | ( | T & | x | ) |

protected

Definition at line 1292 of file opennurbs_array_defs.h.

## EmergencyDestroy()

template<class T >

void ON_ClassArray< T >::EmergencyDestroy | ( | void |  | ) |

Definition at line 995 of file opennurbs_array_defs.h.

## Empty()

template<class T >

void ON_ClassArray< T >::Empty

Definition at line 1413 of file opennurbs_array_defs.h.

## First() [1/2]

template<class T >

T * ON_ClassArray< T >::First

Definition at line 1184 of file opennurbs_array_defs.h.

## First() [2/2]

template<class T >

const T * ON_ClassArray< T >::First

Definition at line 1190 of file opennurbs_array_defs.h.

## HeapSort()

template<class T >

bool ON_ClassArray< T >::HeapSort | ( | int(*)(const T *, const T *) | compar | ) |

virtual

Reimplemented in ON_ObjectArray< T >, ON_ObjectArray< ON_TextureMapping >, ON_ObjectArray< ON_Texture >, ON_ObjectArray< ON_Material >, ON_ObjectArray< ON_Linetype >, ON_ObjectArray< ON_Layer >, ON_ObjectArray< ON_InstanceDefinition >, ON_ObjectArray< ON_HatchPattern >, ON_ObjectArray< ON_Group >, ON_ObjectArray< ON_Font >, ON_ObjectArray< ON_DimStyle >, ON_ObjectArray< ON_BrepVertex >, ON_ObjectArray< ON_BrepTrim >, ON_ObjectArray< ON_BrepRegion >, ON_ObjectArray< ON_BrepLoop >, ON_ObjectArray< ON_BrepFaceSide >, ON_ObjectArray< ON_BrepFace >, and ON_ObjectArray< ON_BrepEdge >.

Definition at line 1495 of file opennurbs_array_defs.h.

## Insert()

template<class T >

void ON_ClassArray< T >::Insert | ( | int | i,
|  | const T & | x
| ) |  |

Definition at line 1363 of file opennurbs_array_defs.h.

## KeepArray()

template<class T >

T * ON_ClassArray< T >::KeepArray

Definition at line 1156 of file opennurbs_array_defs.h.

## Last() [1/2]

template<class T >

T * ON_ClassArray< T >::Last

Definition at line 1246 of file opennurbs_array_defs.h.

## Last() [2/2]

template<class T >

const T * ON_ClassArray< T >::Last

Definition at line 1252 of file opennurbs_array_defs.h.

## Move()

template<class T >

void ON_ClassArray< T >::Move | ( | int | dest_i,
|  | int | src_i,
|  | int | ele_cnt
| ) |  |

protected

Definition at line 1260 of file opennurbs_array_defs.h.

## NewCapacity()

template<class T >

int ON_ClassArray< T >::NewCapacity

Definition at line 826 of file opennurbs_array_defs.h.

## operator const T *()

template<class T >

ON_ClassArray< T >::operator const T *

Definition at line 1138 of file opennurbs_array_defs.h.

## operator T*()

template<class T >

ON_ClassArray< T >::operator T*

Definition at line 1132 of file opennurbs_array_defs.h.

## operator=()

template<class T >

ON_ClassArray< T > & ON_ClassArray< T >::operator= | ( | const ON_ClassArray< T > & | src | ) |

Definition at line 970 of file opennurbs_array_defs.h.

References ON_ClassArray< T >::m_count.

Referenced by ON_ClassArray< ON_HatchLine >::At().

## operator[]() [1/8]

template<class T >

T & ON_ClassArray< T >::operator[] | ( | int | i | ) |

Definition at line 1035 of file opennurbs_array_defs.h.

## operator[]() [2/8]

template<class T >

const T & ON_ClassArray< T >::operator[] | ( | int | i | ) | const

Definition at line 1084 of file opennurbs_array_defs.h.

## operator[]() [3/8]

template<class T >

T & ON_ClassArray< T >::operator[] | ( | ON__INT64 | i | ) |

Definition at line 1048 of file opennurbs_array_defs.h.

## operator[]() [4/8]

template<class T >

const T & ON_ClassArray< T >::operator[] | ( | ON__INT64 | i | ) | const

Definition at line 1096 of file opennurbs_array_defs.h.

## operator[]() [5/8]

template<class T >

T & ON_ClassArray< T >::operator[] | ( | ON__UINT64 | i | ) |

Definition at line 1072 of file opennurbs_array_defs.h.

## operator[]() [6/8]

template<class T >

const T & ON_ClassArray< T >::operator[] | ( | ON__UINT64 | i | ) | const

Definition at line 1120 of file opennurbs_array_defs.h.

## operator[]() [7/8]

template<class T >

T & ON_ClassArray< T >::operator[] | ( | unsigned int | i | ) |

Definition at line 1060 of file opennurbs_array_defs.h.

## operator[]() [8/8]

template<class T >

const T & ON_ClassArray< T >::operator[] | ( | unsigned int | i | ) | const

Definition at line 1108 of file opennurbs_array_defs.h.

## Permute()

template<class T >

bool ON_ClassArray< T >::Permute | ( | const int * | index | ) |

Definition at line 1604 of file opennurbs_array_defs.h.

## QuickSort()

template<class T >

bool ON_ClassArray< T >::QuickSort | ( | int(*)(const T *, const T *) | compar | ) |

virtual

Reimplemented in ON_ObjectArray< T >, ON_ObjectArray< ON_TextureMapping >, ON_ObjectArray< ON_Texture >, ON_ObjectArray< ON_Material >, ON_ObjectArray< ON_Linetype >, ON_ObjectArray< ON_Layer >, ON_ObjectArray< ON_InstanceDefinition >, ON_ObjectArray< ON_HatchPattern >, ON_ObjectArray< ON_Group >, ON_ObjectArray< ON_Font >, ON_ObjectArray< ON_DimStyle >, ON_ObjectArray< ON_BrepVertex >, ON_ObjectArray< ON_BrepTrim >, ON_ObjectArray< ON_BrepRegion >, ON_ObjectArray< ON_BrepLoop >, ON_ObjectArray< ON_BrepFaceSide >, ON_ObjectArray< ON_BrepFace >, and ON_ObjectArray< ON_BrepEdge >.

Definition at line 1508 of file opennurbs_array_defs.h.

## Realloc()

template<class T >

T * ON_ClassArray< T >::Realloc | ( | T * | ptr,
|  | int | capacity
| ) |  |

virtual

Reimplemented in ON_ObjectArray< T >, ON_ObjectArray< ON_TextureMapping >, ON_ObjectArray< ON_Texture >, ON_ObjectArray< ON_Material >, ON_ObjectArray< ON_Linetype >, ON_ObjectArray< ON_Layer >, ON_ObjectArray< ON_InstanceDefinition >, ON_ObjectArray< ON_HatchPattern >, ON_ObjectArray< ON_Group >, ON_ObjectArray< ON_Font >, ON_ObjectArray< ON_DimStyle >, ON_ObjectArray< ON_BrepVertex >, ON_ObjectArray< ON_BrepTrim >, ON_ObjectArray< ON_BrepRegion >, ON_ObjectArray< ON_BrepLoop >, ON_ObjectArray< ON_BrepFaceSide >, ON_ObjectArray< ON_BrepFace >, and ON_ObjectArray< ON_BrepEdge >.

Definition at line 918 of file opennurbs_array_defs.h.

## Remove() [1/2]

template<class T >

void ON_ClassArray< T >::Remove

Definition at line 1389 of file opennurbs_array_defs.h.

## Remove() [2/2]

template<class T >

void ON_ClassArray< T >::Remove | ( | int | i | ) |

Definition at line 1395 of file opennurbs_array_defs.h.

## Reserve()

template<class T >

void ON_ClassArray< T >::Reserve | ( | int | newcap | ) |

Definition at line 1638 of file opennurbs_array_defs.h.

## Reverse()

template<class T >

void ON_ClassArray< T >::Reverse

Definition at line 1427 of file opennurbs_array_defs.h.

## Search()

template<class T >

int ON_ClassArray< T >::Search | ( | const T * | key,
|  | int(*)(const T *, const T *) | compar
| ) |  | const

Definition at line 1454 of file opennurbs_array_defs.h.

## SetArray() [1/2]

template<class T >

void ON_ClassArray< T >::SetArray | ( | T * | p | ) |

Definition at line 1166 of file opennurbs_array_defs.h.

## SetArray() [2/2]

template<class T >

void ON_ClassArray< T >::SetArray | ( | T * | p,
|  | int | count,
|  | int | capacity
| ) |  |

Definition at line 1174 of file opennurbs_array_defs.h.

## SetCapacity()

template<class T >

void ON_ClassArray< T >::SetCapacity | ( | int | capacity | ) |

Definition at line 1666 of file opennurbs_array_defs.h.

## SetCount()

template<class T >

void ON_ClassArray< T >::SetCount | ( | int | count | ) |

Definition at line 1659 of file opennurbs_array_defs.h.

## Shrink()

template<class T >

void ON_ClassArray< T >::Shrink

Definition at line 1645 of file opennurbs_array_defs.h.

## SizeOfArray()

template<class T >

unsigned int ON_ClassArray< T >::SizeOfArray

Definition at line 1023 of file opennurbs_array_defs.h.

## SizeOfElement()

template<class T >

unsigned int ON_ClassArray< T >::SizeOfElement

Definition at line 1029 of file opennurbs_array_defs.h.

## Sort() [1/2]

template<class T >

bool ON_ClassArray< T >::Sort | ( | ON::sort_algorithm | sort_algorithm,
|  | int * | index,
|  | int(*)(const T *, const T *) | compar
| ) |  | const

Definition at line 1574 of file opennurbs_array_defs.h.

## Sort() [2/2]

template<class T >

bool ON_ClassArray< T >::Sort | ( | ON::sort_algorithm | sort_algorithm,
|  | int * | index,
|  | int(*)(const T *, const T *, void *) | compar,
|  | void * | p
| ) |  | const

Definition at line 1589 of file opennurbs_array_defs.h.

## Swap()

template<class T >

void ON_ClassArray< T >::Swap | ( | int | i,
|  | int | j
| ) |  |

Definition at line 1443 of file opennurbs_array_defs.h.

## UnsignedCount()

template<class T >

unsigned int ON_ClassArray< T >::UnsignedCount

Definition at line 1011 of file opennurbs_array_defs.h.

## Zero()

template<class T >

void ON_ClassArray< T >::Zero

Definition at line 1621 of file opennurbs_array_defs.h.

## Member Data Documentation

## m_a

template<class T >

T* ON_ClassArray< T >::m_a

protected

Definition at line 1106 of file opennurbs_array.h.

Referenced by ON_ClassArray< ON_HatchLine >::Sort().

## m_capacity

template<class T >

int ON_ClassArray< T >::m_capacity

protected

Definition at line 1108 of file opennurbs_array.h.

## m_count

template<class T >

int ON_ClassArray< T >::m_count

protected

Definition at line 1107 of file opennurbs_array.h.

Referenced by ON_ClassArray< T >::operator=(), and ON_ClassArray< ON_HatchLine >::Sort().

The documentation for this class was generated from the following files:

- pcl/surface/3rdparty/opennurbs/opennurbs_array.h
- pcl/surface/3rdparty/opennurbs/opennurbs_array_defs.h